SystemOrganization addCategory: #ConfigurationOfLauritzThamsen!

Object subclass: #ConfigurationOfLauritzThamsen
	instanceVariableNames: 'project selected'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfLauritzThamsen'!

ConfigurationOfLauritzThamsen class
	instanceVariableNames: 'accessMap'!

!ConfigurationOfLauritzThamsen commentStamp: 'lt 7/19/2012 16:06' prior: 0!
ConfigurationOfLauritzThamsen is a fork of ConfigurationOfTimFelgentreff-tfel.11 (http://ss3.gemstone.com/ss/timfelgentreff.html).!

ConfigurationOfLauritzThamsen class
	instanceVariableNames: 'accessMap'!

!ConfigurationOfLauritzThamsen class methodsFor: 'accessing' stamp: 'lt 7/31/2012 16:44:21.96'!
accessMap

	| userNames password |
	accessMap ifNotNil: [^ accessMap].
	userNames := Dictionary newFrom: {'ss3' -> 'lauritzthamsen'. 'hirschfeld' -> 'lauritz.thamsen'. 'squeaksource' -> 'LT'}.
	password := UIManager default requestPassword: 'Password for repositories'.
	accessMap := Dictionary new.
	#('ss3' 'hirschfeld' 'squeaksource') do: [:squeaksource |
		accessMap
			at: squeaksource
			put: (userNames at: squeaksource) -> password].
	^ accessMap! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'tfel 2/22/2012 15:57:01.078'!
allWindowsDo: aBlock

	SystemWindow subclasses
		collect: [:k | k allInstances]
		thenDo: [:iary | iary do: aBlock].! !

!ConfigurationOfLauritzThamsen class methodsFor: 'private' stamp: 'tfel 2/2/2012 11:12'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 7/31/2012 16:55:59.555'!
cleanImage

	self hideWindows.
	
	Smalltalk garbageCollect.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 9/3/2012 10:16:37.527'!
configureEnvironment

	self 
		configureTools;
		setPackageCacheDirectory;
		setAuthorInitials.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 11/9/2012 14:54:12.812'!
configureTools

	World color: Preferences defaultWorldColor.
	TextEditor autoEnclose: true.
	MCConfiguration extraProgressInfo: true.
	SystemWindow
		hideExpandButton: true;
		reuseWindows: true.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'private' stamp: 'tfel 2/2/2012 11:12'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfLauritzThamsen class methodsFor: 'private' stamp: 'tfel 2/2/2012 11:12'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 7/31/2012 16:49:19.282'!
hideWindows

	self allWindowsDo: [ :window | window hide ].! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 11/9/2012 15:31:15.312'!
install

	self
		installPatches;
		setPreferences;
		configureEnvironment;
		cleanImage;
		openWorkspaces.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 11/9/2012 15:34:34.614'!
installPatches

	self patches associations 
		select: [ :each |
			Smalltalk datedVersion beginsWith: each key]
		thenDo: [:each |
			(Installer fromUrl: each value) install].
	
! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 1/13/2013 14:30'!
installProjects

	| groups instance mm |
	instance := self new.
	groups := instance project bleedingEdge groups collect: [:group | group name].
	mm := MenuMorph new
		stayUp: true;
		target: instance;
		yourself.
		
	groups do: [:name |
		mm addUpdating: ('IsSelected', name) asSymbol action: ('ToggleSelect', name) asSymbol].

	mm addLine.
	mm add: 'load'
		target: [
			mm abandon.
			instance selected ifNotEmpty: [.
				instance project bleedingEdge load: instance selected asArray.]]
		selector: #value
		argumentList: #().
	mm add: 'cancel'
		target: [
			mm abandon.]
		selector: #value
		argumentList: #().

	mm
		center: ActiveHand center;
		openInWorld.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'metacello tool support' stamp: 'tfel 2/2/2012 11:12'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 11/9/2012 15:18:07.414'!
openVivideWorkspace

	| workspace |
	workspace := Workspace new.
	
	workspace 
		openLabel: 'Vivide Dev';
		contents: 
'(Installer mc http: ''http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/'') 
	project: ''MetacelloRepository'';
	install: ''ConfigurationOfVivide''.
(Smalltalk at: #ConfigurationOfVivide) loadDevelopment.'.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 11/9/2012 15:57:07.397'!
openWelcomeWorkspace

	| workspace |
	workspace := Workspace new.
	
	workspace 
		openLabel: 'Welcome, Lauritz!!';
		contents: 
'ConfigurationOfLauritzThamsen installProjects.

"(Smalltalk at: #UiWorldToolbar) open."'.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 11/9/2012 15:47:17.013'!
openWorkspaces

	self
		openVivideWorkspace;
		openWelcomeWorkspace.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'as yet unclassified' stamp: 'lt 11/9/2012 15:35:28.139'!
patches

	^ Dictionary newFrom: {
		'Squeak4.3' -> 'http://source.squeak.org/trunk/Kernel-eem.692.mcz'.
	}! !

!ConfigurationOfLauritzThamsen class methodsFor: 'accessing' stamp: 'tfel 2/2/2012 11:12'!
project

	^self new project! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 9/3/2012 10:24:01.649'!
setAuthorInitials

	Utilities 
		authorName: 'lauritzthamsen';
		setAuthorInitials: 'lt'.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 12/14/2012 15:10'!
setPackageCacheDirectory

	| packageCacheDirectory |
	packageCacheDirectory := (FileDirectory on: '/Users/lauritz/Code/Smalltalk/Packages/')
		assureExistence;
		yourself.
	MCCacheRepository default directory: packageCacheDirectory.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 11/9/2012 15:57:22.471'!
setPreferences

	Preferences
		enable: #showDeprecationWarnings;
		enable: #swapMouseButtons;
		enable: #infiniteUndo;
		enable: #multipleTextUndo;
		enable: #higherPerformance;
		enable: #annotationPanes;
		enable: #mercuryPanel;
		disable: #fastDragWindowForMorphic;
		disable: #showSharedFlaps.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'tfel 2/22/2012 15:56:43.091'!
showWindows

	self allWindowsDo: [:window | window show].! !

!ConfigurationOfLauritzThamsen class methodsFor: 'development support' stamp: 'tfel 2/2/2012 11:12'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfLauritzThamsen methodsFor: 'private' stamp: 'tfel 4/11/2012 13:49'!
accessAssociationFor: aUrl

	^ (self accessMap associations
		detect: [:assoc | (aUrl includesSubString: assoc key)]
		ifNone: ['' -> ('' -> '')]) value! !

!ConfigurationOfLauritzThamsen methodsFor: 'accessing' stamp: 'tfel 4/17/2012 16:33:16.125'!
accessMap
	"Answer the value of accessMap"

	^ self class accessMap! !

!ConfigurationOfLauritzThamsen methodsFor: 'private' stamp: 'lt 1/13/2013 10:31:35.718'!
addProjects: aListOfSpecs to: spec inVersion: versionString

	aListOfSpecs do: [:array || name url deps configs isPreselected projects | "groupname [url] [deps] [configs] [preselected]"
			name := array first.
			url := (array at: 2 ifAbsent: []) ifNil: ['http://www.squeaksource.com/MetacelloRepository'].
			deps := (array at: 3 ifAbsent: []) ifNil: [#()].
			configs := (array at: 4 ifAbsent: []) ifNil: [{name. #('default')}].
			isPreselected := (array at: 5 ifAbsent: []) ifNil: [false].
			projects := deps asOrderedCollection.
			
			isPreselected ifTrue: [self selectPackage: name].
			
			configs pairsDo: [:projectname :loads |
				projects add: 'Project', projectname.
				spec project: projects last with: [
					spec
						className: 'ConfigurationOf', projectname;
						file: 'ConfigurationOf', projectname;
						repository: url
						username: (self usernameFor: url)
						password: (self passwordFor: url);
						loads: loads;
						versionString: versionString]].
			spec group: name with: projects].! !

!ConfigurationOfLauritzThamsen methodsFor: 'baselines' stamp: 'lt 8/1/2012 16:18:29.615'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/lauritzthamsen'.
		self
			addProjects: self bleedingEdgeProjects to: spec inVersion: #bleedingEdge;
			addProjects: self developmentProjects to: spec inVersion: #development;
			addProjects: self stableProjects to: spec inVersion: #stable.
			
		self specificProjectsWithVersions keysAndValuesDo: [ :project :version | 
			self addProjects: {project} to: spec inVersion: version]].
! !

!ConfigurationOfLauritzThamsen methodsFor: 'specs' stamp: 'lt 1/13/2013 10:18:23.093'!
bleedingEdgeProjects 
	"groupname [url] [deps] [configs] [preselected]"
 	^ #(
	)
! !

!ConfigurationOfLauritzThamsen methodsFor: 'specs' stamp: 'lt 1/13/2013 14:36:22.798000000000002'!
developmentProjects 
	"groupname [url] [deps] [configs] [preselected]"
 	^ #(
		#('Signals' 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository')
		#('Designer' 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository')
		#('SwaOmniBrowser' 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository' nil nil true)
		#('SwaLint' 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository')
	)! !

!ConfigurationOfLauritzThamsen methodsFor: 'error handling' stamp: 'lt 1/13/2013 10:33:07.427'!
doesNotUnderstand: aMessage

	(aMessage selector asString beginsWith: 'IsSelected') ifTrue: [| name |
		name := (aMessage selector asString copyReplaceAll: 'IsSelected' with: '').
		^ self isPackageSelectedString: name].
	(aMessage selector asString beginsWith: 'ToggleSelect') ifTrue: [| name |
		name := (aMessage selector asString copyReplaceAll: 'ToggleSelect' with: '').
		^ self togglePackage: name].

	^ super doesNotUnderstand: aMessage! !

!ConfigurationOfLauritzThamsen methodsFor: 'initialize-release' stamp: 'lt 1/13/2013 10:25:04.105'!
initialize

	super initialize.
	self selected: OrderedCollection new.! !

!ConfigurationOfLauritzThamsen methodsFor: 'actions' stamp: 'lt 1/13/2013 10:33:42.984'!
isPackageSelected: packageName
	^ self selected includes: packageName! !

!ConfigurationOfLauritzThamsen methodsFor: 'actions' stamp: 'lt 1/13/2013 10:33:50.27'!
isPackageSelectedString: packageName

	^ ((self isPackageSelected: packageName)
		ifTrue: [ '<yes>' ]
		ifFalse: [ '<no>' ]) , packageName! !

!ConfigurationOfLauritzThamsen methodsFor: 'private' stamp: 'tfel 4/11/2012 13:48'!
passwordFor: aUrl

	^ (self accessAssociationFor: aUrl) value! !

!ConfigurationOfLauritzThamsen methodsFor: 'accessing' stamp: 'tfel 2/2/2012 11:12'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfLauritzThamsen methodsFor: 'accessing' stamp: 'tfel 2/2/2012 14:08'!
project: anObject
	"Set the value of project"

	project := anObject! !

!ConfigurationOfLauritzThamsen methodsFor: 'accessing' stamp: 'lt 1/13/2013 14:24'!
selectPackage: packageName

	self selected add: packageName.  ! !

!ConfigurationOfLauritzThamsen methodsFor: 'accessing' stamp: 'lt 1/13/2013 14:25'!
selected
	"Answer the value of selected"

	^ selected! !

!ConfigurationOfLauritzThamsen methodsFor: 'accessing' stamp: 'tfel 2/2/2012 14:08'!
selected: anObject
	"Set the value of selected"

	selected := anObject! !

!ConfigurationOfLauritzThamsen methodsFor: 'baselines' stamp: 'lt 1/13/2013 10:13:22.314'!
specificProjectsWithVersions

	^ Dictionary newFrom: {}! !

!ConfigurationOfLauritzThamsen methodsFor: 'specs' stamp: 'lt 1/13/2013 11:12:50.52'!
stableProjects 
	"groupname [url] [deps] [configs] [preselected]"
 	^ #(
			#('FileTree' 'http://ss3.gemstone.com/ss/FileTree' nil nil true)
			#('OSProcess')
			#('MetacelloBrowser' 'http://www.squeaksource.com/MetacelloBrowser/')
			#('Seaside' nil #('OmniBrowser') #('Seaside30' #() 'Magritte2' #('Magritte-Seaside')))
	)! !

!ConfigurationOfLauritzThamsen methodsFor: 'actions' stamp: 'lt 1/13/2013 14:30'!
togglePackage: name

	^ (self selected includes: name)
			ifTrue: [self selected remove: name]
			ifFalse: [self selected add: name]! !

!ConfigurationOfLauritzThamsen methodsFor: 'private' stamp: 'tfel 4/11/2012 13:48'!
usernameFor: aUrl

	^ (self accessAssociationFor: aUrl) key! !
